Index: c/src/lib/libcpu/powerpc/ChangeLog
===================================================================
--- c/src/lib/libcpu/powerpc/ChangeLog	(revision beef85e095906bd4c293e33ac06b4412b275a1c7)
+++ c/src/lib/libcpu/powerpc/ChangeLog	(revision 933fd06ac0b479d7470ab3bfabc28bd3d6112c41)
@@ -1,2 +1,8 @@
+2005-04-15      Jennifer Averett <jennifer.averett@oarcorp.com>
+
+        * mpc6xx/clock/c_clock.c, mpc6xx/clock/c_clock.h,
+        mpc8260/console-generic/console-generic.c: add parameter to new
+        exception interrupt handlers in powerpc bsps
+
 2005-02-17	Ralf Corsepius <ralf.corsepius@rtems.org>
 
Index: c/src/lib/libcpu/powerpc/mpc6xx/clock/c_clock.c
===================================================================
--- c/src/lib/libcpu/powerpc/mpc6xx/clock/c_clock.c	(revision beef85e095906bd4c293e33ac06b4412b275a1c7)
+++ c/src/lib/libcpu/powerpc/mpc6xx/clock/c_clock.c	(revision 933fd06ac0b479d7470ab3bfabc28bd3d6112c41)
@@ -75,5 +75,5 @@
  */
 
-void clockIsr()
+void clockIsr(void *unused)
 {
 int decr;
@@ -202,5 +202,5 @@
 
     if      (args->command == rtems_build_name('I', 'S', 'R', ' '))
-      clockIsr();
+      clockIsr(NULL);
     else if (args->command == rtems_build_name('N', 'E', 'W', ' '))
     {
Index: c/src/lib/libcpu/powerpc/mpc6xx/clock/c_clock.h
===================================================================
--- c/src/lib/libcpu/powerpc/mpc6xx/clock/c_clock.h	(revision beef85e095906bd4c293e33ac06b4412b275a1c7)
+++ c/src/lib/libcpu/powerpc/mpc6xx/clock/c_clock.h	(revision 933fd06ac0b479d7470ab3bfabc28bd3d6112c41)
@@ -32,5 +32,5 @@
 extern void clockOff	(void* unused);
 extern void clockOn	(void* unused);
-extern void clockIsr	(void);
+extern void clockIsr	(void* unused);
 extern int  clockIsOn	(void* unused);
 
Index: c/src/lib/libcpu/powerpc/mpc8260/console-generic/console-generic.c
===================================================================
--- c/src/lib/libcpu/powerpc/mpc8260/console-generic/console-generic.c	(revision beef85e095906bd4c293e33ac06b4412b275a1c7)
+++ c/src/lib/libcpu/powerpc/mpc8260/console-generic/console-generic.c	(revision 933fd06ac0b479d7470ab3bfabc28bd3d6112c41)
@@ -103,10 +103,10 @@
 static int m8xx_smc_set_attributes(int, const struct termios*);
 static int m8xx_scc_set_attributes(int, const struct termios*);
-static rtems_isr m8xx_smc1_interrupt_handler();
-static rtems_isr m8xx_smc2_interrupt_handler();
-static rtems_isr m8xx_scc1_interrupt_handler();
-static rtems_isr m8xx_scc2_interrupt_handler();
-static rtems_isr m8xx_scc3_interrupt_handler();
-static rtems_isr m8xx_scc4_interrupt_handler();
+static rtems_isr m8xx_smc1_interrupt_handler(rtems_irq_hdl_param unused);
+static rtems_isr m8xx_smc2_interrupt_handler(rtems_irq_hdl_param unused);
+static rtems_isr m8xx_scc1_interrupt_handler(rtems_irq_hdl_param unused);
+static rtems_isr m8xx_scc2_interrupt_handler(rtems_irq_hdl_param unused);
+static rtems_isr m8xx_scc3_interrupt_handler(rtems_irq_hdl_param unused);
+static rtems_isr m8xx_scc4_interrupt_handler(rtems_irq_hdl_param unused);
 
 
@@ -353,5 +353,5 @@
 
 static void
-m8xx_scc1_interrupt_handler ()
+m8xx_scc1_interrupt_handler (rtems_irq_hdl_param unused)
 {
   int nb_overflow;
@@ -397,5 +397,5 @@
 
 static void
-m8xx_scc2_interrupt_handler ()
+m8xx_scc2_interrupt_handler (rtems_irq_hdl_param unused)
 {
   int nb_overflow;
@@ -442,5 +442,5 @@
 
 static void
-m8xx_scc3_interrupt_handler ()
+m8xx_scc3_interrupt_handler (rtems_irq_hdl_param unused)
 {
   int nb_overflow;
@@ -488,5 +488,5 @@
 
 static void
-m8xx_scc4_interrupt_handler ()
+m8xx_scc4_interrupt_handler (rtems_irq_hdl_param unused)
 {
   int nb_overflow;
@@ -532,5 +532,5 @@
 
 static void
-m8xx_smc1_interrupt_handler ()
+m8xx_smc1_interrupt_handler (rtems_irq_hdl_param unused)
 {
   int nb_overflow;
@@ -577,5 +577,5 @@
 
 static void
-m8xx_smc2_interrupt_handler ()
+m8xx_smc2_interrupt_handler (rtems_irq_hdl_param unused)
 {
   int nb_overflow;
@@ -678,4 +678,5 @@
   BSP_CPM_IRQ_SCC1,
   (rtems_irq_hdl)m8xx_scc1_interrupt_handler,
+  NULL,
   (rtems_irq_enable) m8xx_scc_enable,
   (rtems_irq_disable) m8xx_scc_disable,