Index: c/src/lib/libbsp/mips/hurricane/ChangeLog
===================================================================
--- c/src/lib/libbsp/mips/hurricane/ChangeLog	(revision 1a813d50f5c41d223b44bafd8f69392b71800655)
+++ c/src/lib/libbsp/mips/hurricane/ChangeLog	(revision 952d8f718a8897ccf86e92541596ad801abf2de4)
@@ -1,2 +1,11 @@
+2009-03-12	Joel Sherrill <joel.sherrill@OARcorp.com>
+
+	PR 1385/cpukit
+	* startup/exception.S: When the type rtems_boolean was switched to the
+	C99 bool, the size changed from 4 bytes to 1 byte. The interrupt
+	dispatching code accesses two boolean variables for scheduling
+	purposes and the assembly implementations of this code did not get
+	updated.
+
 2008-12-08	Ralf CorsÃ©pius <ralf.corsepius@rtems.org>
 
Index: c/src/lib/libbsp/mips/hurricane/startup/exception.S
===================================================================
--- c/src/lib/libbsp/mips/hurricane/startup/exception.S	(revision 1a813d50f5c41d223b44bafd8f69392b71800655)
+++ c/src/lib/libbsp/mips/hurricane/startup/exception.S	(revision 952d8f718a8897ccf86e92541596ad801abf2de4)
@@ -98,6 +98,6 @@
 EXTERN(_ISR_Nest_level, 4)
 EXTERN(_Thread_Dispatch_disable_level,4)
-EXTERN(_Context_Switch_necessary,4)
-EXTERN(_ISR_Signals_to_thread_executing,4)
+EXTERN(_Context_Switch_necessary,1)
+EXTERN(_ISR_Signals_to_thread_executing,1)
 .extern _Thread_Dispatch
 .extern _ISR_Vector_table
@@ -282,8 +282,8 @@
    *    goto the label "exit interrupt (simple case)"
    */
-        lw	t0,_Context_Switch_necessary
-        lw	t1,_ISR_Signals_to_thread_executing
-	NOP
-        or	t0,t0,t1
+        lb	t0,_Context_Switch_necessary
+        lb	t1,_ISR_Signals_to_thread_executing
+	NOP
+        or 	t0,t0,t1
         beq	t0,zero,_ISR_Handler_exit
         NOP
@@ -417,4 +417,5 @@
         
         bgez	k0,USC_isr2	/* branch if not a heartbeat interrupt */
+	NOP
 
 	/* clear the heartbeat interrupt */
Index: c/src/lib/libbsp/mips/rbtx4925/ChangeLog
===================================================================
--- c/src/lib/libbsp/mips/rbtx4925/ChangeLog	(revision 1a813d50f5c41d223b44bafd8f69392b71800655)
+++ c/src/lib/libbsp/mips/rbtx4925/ChangeLog	(revision 952d8f718a8897ccf86e92541596ad801abf2de4)
@@ -1,2 +1,11 @@
+2009-03-12	Joel Sherrill <joel.sherrill@OARcorp.com>
+
+	PR 1385/cpukit
+	* startup/exception.S: When the type rtems_boolean was switched to the
+	C99 bool, the size changed from 4 bytes to 1 byte. The interrupt
+	dispatching code accesses two boolean variables for scheduling
+	purposes and the assembly implementations of this code did not get
+	updated.
+
 2008-12-08	Ralf CorsÃ©pius <ralf.corsepius@rtems.org>
 
Index: c/src/lib/libbsp/mips/rbtx4925/startup/exception.S
===================================================================
--- c/src/lib/libbsp/mips/rbtx4925/startup/exception.S	(revision 1a813d50f5c41d223b44bafd8f69392b71800655)
+++ c/src/lib/libbsp/mips/rbtx4925/startup/exception.S	(revision 952d8f718a8897ccf86e92541596ad801abf2de4)
@@ -97,6 +97,6 @@
 EXTERN(_ISR_Nest_level, 4)
 EXTERN(_Thread_Dispatch_disable_level,4)
-EXTERN(_Context_Switch_necessary,4)
-EXTERN(_ISR_Signals_to_thread_executing,4)
+EXTERN(_Context_Switch_necessary,1)
+EXTERN(_ISR_Signals_to_thread_executing,1)
 .extern _Thread_Dispatch
 .extern _ISR_Vector_table
@@ -322,8 +322,8 @@
    *    goto the label "exit interrupt (simple case)"
    */
-        lw	t0,_Context_Switch_necessary
-        lw	t1,_ISR_Signals_to_thread_executing
-	NOP
-        or	t0,t0,t1
+        lb	t0,_Context_Switch_necessary
+        lb	t1,_ISR_Signals_to_thread_executing
+	NOP
+        or 	t0,t0,t1
         beq	t0,zero,_ISR_Handler_exit
         NOP
Index: c/src/lib/libbsp/mips/rbtx4938/ChangeLog
===================================================================
--- c/src/lib/libbsp/mips/rbtx4938/ChangeLog	(revision 1a813d50f5c41d223b44bafd8f69392b71800655)
+++ c/src/lib/libbsp/mips/rbtx4938/ChangeLog	(revision 952d8f718a8897ccf86e92541596ad801abf2de4)
@@ -1,2 +1,11 @@
+2009-03-12	Joel Sherrill <joel.sherrill@OARcorp.com>
+
+	PR 1385/cpukit
+	* startup/exception.S: When the type rtems_boolean was switched to the
+	C99 bool, the size changed from 4 bytes to 1 byte. The interrupt
+	dispatching code accesses two boolean variables for scheduling
+	purposes and the assembly implementations of this code did not get
+	updated.
+
 2008-12-08	Ralf CorsÃ©pius <ralf.corsepius@rtems.org>
 
Index: c/src/lib/libbsp/mips/rbtx4938/startup/exception.S
===================================================================
--- c/src/lib/libbsp/mips/rbtx4938/startup/exception.S	(revision 1a813d50f5c41d223b44bafd8f69392b71800655)
+++ c/src/lib/libbsp/mips/rbtx4938/startup/exception.S	(revision 952d8f718a8897ccf86e92541596ad801abf2de4)
@@ -97,6 +97,6 @@
 EXTERN(_ISR_Nest_level, 4)
 EXTERN(_Thread_Dispatch_disable_level,4)
-EXTERN(_Context_Switch_necessary,4)
-EXTERN(_ISR_Signals_to_thread_executing,4)
+EXTERN(_Context_Switch_necessary,1)
+EXTERN(_ISR_Signals_to_thread_executing,1)
 .extern _Thread_Dispatch
 .extern _ISR_Vector_table
@@ -322,8 +322,8 @@
    *    goto the label "exit interrupt (simple case)"
    */
-        lw	t0,_Context_Switch_necessary
-        lw	t1,_ISR_Signals_to_thread_executing
-	NOP
-        or	t0,t0,t1
+        lb	t0,_Context_Switch_necessary
+        lb	t1,_ISR_Signals_to_thread_executing
+	NOP
+        or 	t0,t0,t1
         beq	t0,zero,_ISR_Handler_exit
         NOP