Index: tools/gdb/python/__init__.py
===================================================================
--- tools/gdb/python/__init__.py	(revision a785e254f2360e946baa14a11fbd3f403047b880)
+++ tools/gdb/python/__init__.py	(revision 0967a1b679495f728781bd05318379024cadf5c5)
@@ -14,5 +14,5 @@
     import classic_printer
 
-    # Needed to reload code inside gdb source command
+    # Needed inorder to reload code from inside gdb
     reload(supercore)
     reload(chains)
@@ -23,3 +23,4 @@
     reload(supercore_printer)
     reload(classic_printer)
+
     print 'RTEMS GDB Support loaded'
Index: tools/gdb/python/classic.py
===================================================================
--- tools/gdb/python/classic.py	(revision a785e254f2360e946baa14a11fbd3f403047b880)
+++ tools/gdb/python/classic.py	(revision 0967a1b679495f728781bd05318379024cadf5c5)
@@ -80,4 +80,5 @@
         self.attr = attr
 
+    #ToDo: Move this out
     def to_string(self):
         s = '0x%08x,' % (self.attr)
Index: tools/gdb/python/classic_printer.py
===================================================================
--- tools/gdb/python/classic_printer.py	(revision a785e254f2360e946baa14a11fbd3f403047b880)
+++ tools/gdb/python/classic_printer.py	(revision 0967a1b679495f728781bd05318379024cadf5c5)
@@ -3,5 +3,5 @@
 #
 
-class attribute_printer:
+class attribute:
 
     def __init__(self, attribute):
@@ -12,6 +12,6 @@
         return gdb.Value(self.attr.to_string())
 
-class semaphore_printer:
-    """WIP: Print a Semaphore_Control object. Print using the struct display hint
+class semaphore:
+    """ToDo: Print a Semaphore_Control object. Print using the struct display hint
     and an iterator. """
 
Index: tools/gdb/python/helper.py
===================================================================
--- tools/gdb/python/helper.py	(revision 0967a1b679495f728781bd05318379024cadf5c5)
+++ tools/gdb/python/helper.py	(revision 0967a1b679495f728781bd05318379024cadf5c5)
@@ -0,0 +1,8 @@
+#
+# RTEMS GDB support helper routins.
+
+def tasks_printer_rotuine(wait_queue):
+    tasks = wait_queue.tasks()
+    print '    Queue: len = %d, state = %s' % (len(tasks),wait_queue.state())
+    for t in range(0, len(tasks)):
+        print '      ', tasks[t].brief(), ' (%08x)' % (tasks[t].id())
Index: tools/gdb/python/objects.py
===================================================================
--- tools/gdb/python/objects.py	(revision a785e254f2360e946baa14a11fbd3f403047b880)
+++ tools/gdb/python/objects.py	(revision 0967a1b679495f728781bd05318379024cadf5c5)
@@ -247,51 +247,2 @@
         is_string = information.is_string(self._id.api(), self._id._class())
         return str(name(self.object['name'], is_string))
-
-
-
-
-class control_printer:
-
-    class iterator:
-        """Use an iterator for each field expanded from the id so GDB output
-        is formatted correctly."""
-
-        def __init__(self, object):
-            self.object = object
-            self.count = 0
-
-        def __iter__(self):
-            return self
-
-        def next(self):
-            self.count += 1
-            if self.count == 1:
-                return self.object.node()
-            elif self.count == 2:
-                return self.object.id()
-            elif self.count == 3:
-                return self.object.name()
-            raise StopIteration
-
-    def to_string(self):
-        return ''
-
-    def __init__(self, object):
-        self.object = control(object)
-
-    @staticmethod
-    def key(i):
-        if i == 0:
-            return 'Node'
-        elif i == 1:
-            return 'id'
-        elif i == 2:
-            return 'name'
-        return 'bad'
-
-    def children(self):
-        counter = itertools.imap (self.key, itertools.count())
-        return itertools.izip (counter, self.iterator(self.object))
-
-    def display_hint (self):
-        return 'struct'
Index: tools/gdb/python/rtems.py
===================================================================
--- tools/gdb/python/rtems.py	(revision a785e254f2360e946baa14a11fbd3f403047b880)
+++ tools/gdb/python/rtems.py	(revision 0967a1b679495f728781bd05318379024cadf5c5)
@@ -55,11 +55,11 @@
 
 def build_rtems_dict():
-    pp_dict[re.compile('^rtems_id$')]   = lambda val: supercore_printer.id_printer(val)
-    pp_dict[re.compile('^Objects_Id$')] = lambda val: supercore_printer.id_printer(val)
-    pp_dict[re.compile('^Objects_Name$')] = lambda val: supercore_printer.name_printer(val)
-    pp_dict[re.compile('^Objects_Control$')] = lambda val: supercore_printer.control_printer(val)
-    pp_dict[re.compile('^States_Control$')] = lambda val: supercore_printer.state_printer(val)
-    pp_dict[re.compile('^rtems_attribute$')] = lambda val: classic_printer.attribute_printer(val)
-    pp_dict[re.compile('^Semaphore_Control$')] = lambda val: classic_printer.semaphore_printer(val)
+    pp_dict[re.compile('^rtems_id$')]   = lambda val: supercore_printer.id(val)
+    pp_dict[re.compile('^Objects_Id$')] = lambda val: supercore_printer.id(val)
+    pp_dict[re.compile('^Objects_Name$')] = lambda val: supercore_printer.name(val)
+    pp_dict[re.compile('^Objects_Control$')] = lambda val: supercore_printer.control(val)
+    pp_dict[re.compile('^States_Control$')] = lambda val: supercore_printer.state(val)
+    pp_dict[re.compile('^rtems_attribute$')] = lambda val: classic_printer.attribute(val)
+    pp_dict[re.compile('^Semaphore_Control$')] = lambda val: classic_printer.semaphore(val)
 
 class rtems(gdb.Command):
Index: tools/gdb/python/supercore.py
===================================================================
--- tools/gdb/python/supercore.py	(revision a785e254f2360e946baa14a11fbd3f403047b880)
+++ tools/gdb/python/supercore.py	(revision 0967a1b679495f728781bd05318379024cadf5c5)
@@ -4,11 +4,5 @@
 
 import threads
-
-# ToDo: Move this to helper.
-def tasks_printer_rotuine(wait_queue):
-    tasks = wait_queue.tasks()
-    print '    Queue: len = %d, state = %s' % (len(tasks),wait_queue.state())
-    for t in range(0, len(tasks)):
-        print '      ', tasks[t].brief(), ' (%08x)' % (tasks[t].id())
+import helper
 
 class CORE_message_queue:
@@ -22,3 +16,3 @@
 
     def show(self):
-        tasks_printer_rotuine(self.wait_queue)
+        helper.tasks_printer_rotuine(self.wait_queue)
Index: tools/gdb/python/supercore_printer.py
===================================================================
--- tools/gdb/python/supercore_printer.py	(revision a785e254f2360e946baa14a11fbd3f403047b880)
+++ tools/gdb/python/supercore_printer.py	(revision 0967a1b679495f728781bd05318379024cadf5c5)
@@ -5,5 +5,5 @@
 import itertools
 
-class id_printer:
+class id:
     """Print an object given the ID. Print using the struct display hint and an
     iterator."""
@@ -61,5 +61,5 @@
         return 'struct'
 
-class name_printer:
+class name:
     """Pretty printer for an object's name. It has to guess the type as no
     information is available to help determine it."""
@@ -71,5 +71,5 @@
         return str(self.name)
 
-class control_printer:
+class control:
 
     class iterator:
@@ -118,5 +118,5 @@
 
 
-class state_printer:
+class state:
 
     def __init__(self, state):
@@ -125,5 +125,5 @@
         return self.state.to_string()
 
-class chains_printer:
+class chains:
 
     def __init__(self,chain):
@@ -133,5 +133,5 @@
         return "First:"+str(self.chain.first())+"\n Last:"+str(self.chain.last())
 
-class node_printer:
+class node:
     def __init__(self, node):
         self.node = chains.node(node)