Index: bsp-howto/index.rst
===================================================================
--- bsp-howto/index.rst	(revision 5577cc082a7a782625bb1c8385ec06c900e0372e)
+++ bsp-howto/index.rst	(revision 969e60e59612eeeb5c22b6f6c2d60d6c43d183be)
@@ -7,5 +7,5 @@
  | **COPYRIGHT (c) 1988 - 2015.**
  | **On-Line Applications Research Corporation (OAR).**
- | **COPYRIGHT (c) 2016-2017.**
+ | **COPYRIGHT (c) 2016-2018.**
  | **RTEMS Foundation, The RTEMS Documentation Project**
 
Index: c-user/index.rst
===================================================================
--- c-user/index.rst	(revision 5577cc082a7a782625bb1c8385ec06c900e0372e)
+++ c-user/index.rst	(revision 969e60e59612eeeb5c22b6f6c2d60d6c43d183be)
@@ -7,5 +7,5 @@
  | **COPYRIGHT (c) 1988 - 2015.**
  | **On-Line Applications Research Corporation (OAR).**
- | **COPYRIGHT (c) 2016-2017.**
+ | **COPYRIGHT (c) 2016-2018.**
  | **RTEMS Foundation, The RTEMS Documentation Project**
 
Index: common/conf.py
===================================================================
--- common/conf.py	(revision 5577cc082a7a782625bb1c8385ec06c900e0372e)
+++ common/conf.py	(revision 969e60e59612eeeb5c22b6f6c2d60d6c43d183be)
@@ -48,5 +48,5 @@
 # General information about the project.
 project = u'RTEMS Documentation Project'
-copyright = u'2017, RTEMS Project (built %s)' % (build_date())
+copyright = u'2018, RTEMS Project (built %s)' % (build_date())
 
 # The version info for the project you're documenting, acts as replacement for
Index: cpu-supplement/index.rst
===================================================================
--- cpu-supplement/index.rst	(revision 5577cc082a7a782625bb1c8385ec06c900e0372e)
+++ cpu-supplement/index.rst	(revision 969e60e59612eeeb5c22b6f6c2d60d6c43d183be)
@@ -7,5 +7,5 @@
  | **COPYRIGHT (c) 1988 - 2015.**
  | **On-Line Applications Research Corporation (OAR).**
- | **COPYRIGHT (c) 2016-2017.**
+ | **COPYRIGHT (c) 2016-2018.**
  | **RTEMS Foundation, The RTEMS Documentation Project**
 
Index: develenv/index.rst
===================================================================
--- develenv/index.rst	(revision 5577cc082a7a782625bb1c8385ec06c900e0372e)
+++ develenv/index.rst	(revision 969e60e59612eeeb5c22b6f6c2d60d6c43d183be)
@@ -7,5 +7,5 @@
  | **COPYRIGHT (c) 1988 - 2015.**
  | **On-Line Applications Research Corporation (OAR).**
- | **COPYRIGHT (c) 2016-2017.**
+ | **COPYRIGHT (c) 2016-2018.**
  | **RTEMS Foundation, The RTEMS Documentation Project**
 
Index: eclipse/index.rst
===================================================================
--- eclipse/index.rst	(revision 5577cc082a7a782625bb1c8385ec06c900e0372e)
+++ eclipse/index.rst	(revision 969e60e59612eeeb5c22b6f6c2d60d6c43d183be)
@@ -10,5 +10,5 @@
 =================================
 
- | **COPYRIGHT (c) 2016-2017.**
+ | **COPYRIGHT (c) 2016-2018.**
  | **RTEMS Foundation, The RTEMS Documentation Project**
 
Index: filesystem/index.rst
===================================================================
--- filesystem/index.rst	(revision 5577cc082a7a782625bb1c8385ec06c900e0372e)
+++ filesystem/index.rst	(revision 969e60e59612eeeb5c22b6f6c2d60d6c43d183be)
@@ -7,5 +7,5 @@
  | **COPYRIGHT (c) 1988 - 2015.**
  | **On-Line Applications Research Corporation (OAR).**
- | **COPYRIGHT (c) 2016-2017.**
+ | **COPYRIGHT (c) 2016-2018.**
  | **RTEMS Foundation, The RTEMS Documentation Project**
 
Index: networking/index.rst
===================================================================
--- networking/index.rst	(revision 5577cc082a7a782625bb1c8385ec06c900e0372e)
+++ networking/index.rst	(revision 969e60e59612eeeb5c22b6f6c2d60d6c43d183be)
@@ -9,5 +9,5 @@
  | **COPYRIGHT (c) 1988 - 2015.**
  | **On-Line Applications Research Corporation (OAR).**
- | **COPYRIGHT (c) 2016-2017.**
+ | **COPYRIGHT (c) 2016-2018.**
  | **RTEMS Foundation, The RTEMS Documentation Project**
 
Index: porting/index.rst
===================================================================
--- porting/index.rst	(revision 5577cc082a7a782625bb1c8385ec06c900e0372e)
+++ porting/index.rst	(revision 969e60e59612eeeb5c22b6f6c2d60d6c43d183be)
@@ -7,5 +7,5 @@
  | **COPYRIGHT (c) 1988 - 2015.**
  | **On-Line Applications Research Corporation (OAR).**
- | **COPYRIGHT (c) 2016-2017.**
+ | **COPYRIGHT (c) 2016-2018.**
  | **RTEMS Foundation, The RTEMS Documentation Project**
 
Index: posix-compliance/index.rst
===================================================================
--- posix-compliance/index.rst	(revision 5577cc082a7a782625bb1c8385ec06c900e0372e)
+++ posix-compliance/index.rst	(revision 969e60e59612eeeb5c22b6f6c2d60d6c43d183be)
@@ -7,5 +7,5 @@
  | **COPYRIGHT (c) 1988 - 2015.**
  | **On-Line Applications Research Corporation (OAR).**
- | **COPYRIGHT (c) 2016-2017.**
+ | **COPYRIGHT (c) 2016-2018.**
  | **RTEMS Foundation, The RTEMS Documentation Project**
 
Index: posix-users/index.rst
===================================================================
--- posix-users/index.rst	(revision 5577cc082a7a782625bb1c8385ec06c900e0372e)
+++ posix-users/index.rst	(revision 969e60e59612eeeb5c22b6f6c2d60d6c43d183be)
@@ -7,5 +7,5 @@
  | **COPYRIGHT (c) 1988 - 2015.**
  | **On-Line Applications Research Corporation (OAR).**
- | **COPYRIGHT (c) 2016-2017.**
+ | **COPYRIGHT (c) 2016-2018.**
  | **RTEMS Foundation, The RTEMS Documentation Project**
 
Index: rsb/index.rst
===================================================================
--- rsb/index.rst	(revision 5577cc082a7a782625bb1c8385ec06c900e0372e)
+++ rsb/index.rst	(revision 969e60e59612eeeb5c22b6f6c2d60d6c43d183be)
@@ -15,5 +15,5 @@
  | **COPYRIGHT (c) 2012 - 2015.**
  | **Chris Johns <chrisj@rtems.org>**
- | **COPYRIGHT (c) 2016-2017.**
+ | **COPYRIGHT (c) 2016-2018.**
  | **RTEMS Foundation, The RTEMS Documentation Project**
 
Index: shell/index.rst
===================================================================
--- shell/index.rst	(revision 5577cc082a7a782625bb1c8385ec06c900e0372e)
+++ shell/index.rst	(revision 969e60e59612eeeb5c22b6f6c2d60d6c43d183be)
@@ -11,5 +11,5 @@
  | **COPYRIGHT (c) 1988 - 2015.**
  | **On-Line Applications Research Corporation (OAR).**
- | **COPYRIGHT (c) 2016-2017.**
+ | **COPYRIGHT (c) 2016-2018.**
  | **RTEMS Foundation, The RTEMS Documentation Project**
 
Index: user/index.rst
===================================================================
--- user/index.rst	(revision 5577cc082a7a782625bb1c8385ec06c900e0372e)
+++ user/index.rst	(revision 969e60e59612eeeb5c22b6f6c2d60d6c43d183be)
@@ -7,5 +7,5 @@
 ==============================
 
- | **COPYRIGHT (c) 2016-2017.**
+ | **COPYRIGHT (c) 2016-2018.**
  | **RTEMS Foundation, The RTEMS Documentation Project**
 