Index: c/src/lib/libbsp/mips/p4000/start/start.S
===================================================================
--- c/src/lib/libbsp/mips/p4000/start/start.S	(revision 5bb00a8bd3e40e0d11fbf5e7a70c075b8a2436e9)
+++ c/src/lib/libbsp/mips/p4000/start/start.S	(revision 0971cd5b5a9ff352835d57164fad922b608db552)
@@ -21,4 +21,5 @@
 LICENSED MATERIAL - PROGRAM PROPERTY OF IDT
 
+  $Id$
 */ 
 
Index: c/src/lib/libbsp/mips64orion/p4000/start/start.S
===================================================================
--- c/src/lib/libbsp/mips64orion/p4000/start/start.S	(revision 5bb00a8bd3e40e0d11fbf5e7a70c075b8a2436e9)
+++ c/src/lib/libbsp/mips64orion/p4000/start/start.S	(revision 0971cd5b5a9ff352835d57164fad922b608db552)
@@ -21,4 +21,5 @@
 LICENSED MATERIAL - PROGRAM PROPERTY OF IDT
 
+  $Id$
 */ 
 
Index: c/src/lib/libcpu/mips/clock/ckinit.c
===================================================================
--- c/src/lib/libcpu/mips/clock/ckinit.c	(revision 5bb00a8bd3e40e0d11fbf5e7a70c075b8a2436e9)
+++ c/src/lib/libcpu/mips/clock/ckinit.c	(revision 0971cd5b5a9ff352835d57164fad922b608db552)
@@ -29,5 +29,5 @@
  *  notice must appear in all copies of this file and its derivatives.
  *
- *  ckinit.c,v 1.5 1995/10/30 21:53:23 joel Exp
+ *  $Id$
  */
 
Index: c/src/lib/libcpu/mips/clock/clock.S
===================================================================
--- c/src/lib/libcpu/mips/clock/clock.S	(revision 5bb00a8bd3e40e0d11fbf5e7a70c075b8a2436e9)
+++ c/src/lib/libcpu/mips/clock/clock.S	(revision 0971cd5b5a9ff352835d57164fad922b608db552)
@@ -18,4 +18,5 @@
  *      of this software for any purpose.
  *
+ *  $Id$
  */
 /* @(#)clock.S       08/20/96     1.2 */
Index: c/src/lib/libcpu/mips/clock/clock.h
===================================================================
--- c/src/lib/libcpu/mips/clock/clock.h	(revision 5bb00a8bd3e40e0d11fbf5e7a70c075b8a2436e9)
+++ c/src/lib/libcpu/mips/clock/clock.h	(revision 0971cd5b5a9ff352835d57164fad922b608db552)
@@ -18,4 +18,5 @@
  *      of this software for any purpose.
  *
+ *  $Id$
  */
 
Index: c/src/lib/libcpu/mips/timer/gettime.S
===================================================================
--- c/src/lib/libcpu/mips/timer/gettime.S	(revision 5bb00a8bd3e40e0d11fbf5e7a70c075b8a2436e9)
+++ c/src/lib/libcpu/mips/timer/gettime.S	(revision 0971cd5b5a9ff352835d57164fad922b608db552)
@@ -18,4 +18,5 @@
  *      of this software for any purpose.
  *
+ *  $Id$
  */
 
Index: c/src/lib/libcpu/mips/timer/timer.c
===================================================================
--- c/src/lib/libcpu/mips/timer/timer.c	(revision 5bb00a8bd3e40e0d11fbf5e7a70c075b8a2436e9)
+++ c/src/lib/libcpu/mips/timer/timer.c	(revision 0971cd5b5a9ff352835d57164fad922b608db552)
@@ -36,5 +36,5 @@
  *  notice must appear in all copies of this file and its derivatives.
  *
- *  timer.c,v 1.2 1995/05/31 16:56:39 joel Exp
+ *  $Id$
  */
 
Index: c/src/lib/libcpu/mips64orion/clock/ckinit.c
===================================================================
--- c/src/lib/libcpu/mips64orion/clock/ckinit.c	(revision 5bb00a8bd3e40e0d11fbf5e7a70c075b8a2436e9)
+++ c/src/lib/libcpu/mips64orion/clock/ckinit.c	(revision 0971cd5b5a9ff352835d57164fad922b608db552)
@@ -29,5 +29,5 @@
  *  notice must appear in all copies of this file and its derivatives.
  *
- *  ckinit.c,v 1.5 1995/10/30 21:53:23 joel Exp
+ *  $Id$
  */
 
Index: c/src/lib/libcpu/mips64orion/clock/clock.S
===================================================================
--- c/src/lib/libcpu/mips64orion/clock/clock.S	(revision 5bb00a8bd3e40e0d11fbf5e7a70c075b8a2436e9)
+++ c/src/lib/libcpu/mips64orion/clock/clock.S	(revision 0971cd5b5a9ff352835d57164fad922b608db552)
@@ -18,4 +18,5 @@
  *      of this software for any purpose.
  *
+ *  $Id$
  */
 /* @(#)clock.S       08/20/96     1.2 */
Index: c/src/lib/libcpu/mips64orion/clock/clock.h
===================================================================
--- c/src/lib/libcpu/mips64orion/clock/clock.h	(revision 5bb00a8bd3e40e0d11fbf5e7a70c075b8a2436e9)
+++ c/src/lib/libcpu/mips64orion/clock/clock.h	(revision 0971cd5b5a9ff352835d57164fad922b608db552)
@@ -18,4 +18,5 @@
  *      of this software for any purpose.
  *
+ *  $Id$
  */
 
Index: c/src/lib/libcpu/mips64orion/timer/gettime.S
===================================================================
--- c/src/lib/libcpu/mips64orion/timer/gettime.S	(revision 5bb00a8bd3e40e0d11fbf5e7a70c075b8a2436e9)
+++ c/src/lib/libcpu/mips64orion/timer/gettime.S	(revision 0971cd5b5a9ff352835d57164fad922b608db552)
@@ -18,4 +18,5 @@
  *      of this software for any purpose.
  *
+ *  $Id$
  */
 
Index: c/src/lib/libcpu/mips64orion/timer/timer.c
===================================================================
--- c/src/lib/libcpu/mips64orion/timer/timer.c	(revision 5bb00a8bd3e40e0d11fbf5e7a70c075b8a2436e9)
+++ c/src/lib/libcpu/mips64orion/timer/timer.c	(revision 0971cd5b5a9ff352835d57164fad922b608db552)
@@ -36,5 +36,5 @@
  *  notice must appear in all copies of this file and its derivatives.
  *
- *  timer.c,v 1.2 1995/05/31 16:56:39 joel Exp
+ *  $Id$
  */
 
Index: c/src/lib/start/mips64orion/idt_csu.S
===================================================================
--- c/src/lib/start/mips64orion/idt_csu.S	(revision 5bb00a8bd3e40e0d11fbf5e7a70c075b8a2436e9)
+++ c/src/lib/start/mips64orion/idt_csu.S	(revision 0971cd5b5a9ff352835d57164fad922b608db552)
@@ -21,4 +21,5 @@
 LICENSED MATERIAL - PROGRAM PROPERTY OF IDT
 
+  $Id$
 */ 
 